package com.maroontress.testfunnel.auditor;

import java.io.IOException;
import java.io.InputStream;
import java.io.ByteArrayInputStream;
import java.util.Arrays;
import java.util.Collection;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.SortedMap;
import java.util.TreeMap;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
   ƥȥեͥ롣

   쥷ԤȸƤФեͥƥȹܤXMLǵҤΤˤꡢ
   ƥȥեͥƤꤵޤ饤¦Υեͥ
   ³ľ塢쥷Ԥơ饤¦Υեͥߥ顼
   ޤ
*/
public class Funnel {

    /** ƥȤ */
    private Test[] tests;

    /**
       ƥȤΥĥ꡼ޥåפǤ

        <饹̾>#<᥽å̾>Ǥ
    */
    private TreeMap<String, Test> testTree;

    /**
       ƥȤΥ饹ǼϥåޥåפǤ

        <饹̾> Ǥ
    */
    private HashMap<String, String> descriptions;

    /** ƥȤΥ饹̾Υѥ졼 */
    private Comparator<Test> classComparator;

    /** ƥȤΥ᥽å̾Υѥ졼 */
    private Comparator<Test> nameComparator;

    /** ƥȤξ֤Υѥ졼 */
    private Comparator<Test> statusComparator;

    /** ŬѤƤƥȤΥѥ졼 */
    private Comparator<Test> comparator;

    /** եͥѲΤꥹʤν */
    private HashSet<FunnelListener> listeners;

    /** */
    private TestListener testListener;

    /** */
    private HashMap<Test, Integer> index;

    /**
       եͥѲΤꥹʤɲäޤ

       @param listener եͥѲΤ뤿Υꥹ
    */
    public final void addFunnelListener(final FunnelListener listener) {
	listeners.add(listener);
    }

    /**
       եͥѲΤꥹʤޤ

       @param listener եͥѲΤ뤿Υꥹ
    */
    public final void removeFunnelListener(final FunnelListener listener) {
	listeners.remove(listener);
    }

    /**
       쥷ԤѹˤʤäȤꥹʤΤޤ
    */
    private void notifyRecipeChanged() {
	for (FunnelListener listener : listeners) {
	    listener.recipeChanged();
	}
    }

    /**
       쥷Ԥꤷޤ

       @param recipe 쥷
       @throws ProtocolException ץȥ˴ְ㤤äȤ
       ޤ
    */
    public void setRecipe(final byte[] recipe) throws ProtocolException {
	InputStream in = new ByteArrayInputStream(recipe);
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        Document doc;
        try {
            DocumentBuilder builder = factory.newDocumentBuilder();
            doc = builder.parse(in);
        } catch (ParserConfigurationException e) {
            throw new ProtocolException(e);
        } catch (SAXException e) {
            throw new ProtocolException(e);
        } catch (IOException e) {
	    throw new ProtocolException(e);
        }
        Element root = doc.getDocumentElement();
        NodeList classes = root.getElementsByTagName("class");

	testTree.clear();
	descriptions.clear();
        for (int k = 0; k < classes.getLength(); ++k) {
            Element clazz = (Element) classes.item(k);
	    NodeList classMethods = clazz.getElementsByTagName("method");
	    String className = clazz.getAttribute("name");
	    String classDesc = clazz.getAttribute("description");
	    for (int j = 0; j < classMethods.getLength(); ++j) {
		Element method = (Element) classMethods.item(j);
		String methodName = method.getAttribute("name");
		testTree.put(className + "#" + methodName,
			     new Test(testListener, className, methodName));
	    }
	    descriptions.put(className, classDesc);
        }
	setTests(testTree.values());
	notifyRecipeChanged();
    }

    /**
       Υեͥޤ
    */
    public Funnel() {
	testListener = new TestListener() {
	    public void selectionChanged(final Test t) {
		for (FunnelListener listener : listeners) {
		    listener.selectionChanged();
		}
	    }
	    public void statusChanged(final Test t) {
		for (FunnelListener listener : listeners) {
		    listener.statusChanged(t);
		}
	    }
	};
	listeners = new HashSet<FunnelListener>();
	testTree = new TreeMap<String, Test>();
	descriptions = new HashMap<String, String>();
	classComparator = new Comparator<Test>() {
	    public int compare(final Test t1, final Test t2) {
		return t1.getClassName().compareTo(t2.getClassName());
	    }
	};
	nameComparator = new Comparator<Test>() {
	    public int compare(final Test t1, final Test t2) {
		return t1.getMethodName().compareTo(t2.getMethodName());
	    }
	};
	statusComparator = new Comparator<Test>() {
	    public int compare(final Test t1, final Test t2) {
		return (t1.getStatus() - t2.getStatus());
	    }
	};
	comparator = classComparator;
	tests = new Test[0];
	index = new HashMap<Test, Integer>();
    }

    /**
       ƥȤθĿ֤ޤ

       @return ƥȤθĿ
    */
    public final int getTestSize() {
	return tests.length;
    }

    /**
       ꤷֹΥƥȤ֤ޤ

       @param k ƥȤֹ
       @return ƥ
    */
    public final Test getTest(final int k) {
	return tests[k];
    }

    /**
       ꤷƥȤֹ֤ޤ

       ƥȤեͥ˴ޤޤƤʤ硢ޤϹʤ߷̤˴
       ޤƤʤ-1֤ޤ

       @param t ƥ
       @return ƥȤֹ桢ޤ-1
    */
    public final int getIndex(final Test t) {
	Integer i = index.get(t);
	return (i == null) ? -1 : i;
    }

    /**
       ƥȤΥ饹֤̾ޤ

       饹̾ϼ˥ȤƤޤ

       @return 饹̾
    */
    public final String[] getClassNames() {
	String s[] = new String[0];
	s = descriptions.keySet().toArray(s);
	Arrays.sort(s);
	return s;
    }

    /**
       Ⱦ郎ѹˤʤäȤꥹʤΤޤ
    */
    private void notifySortKeyChanged() {
	for (FunnelListener listener : listeners) {
	    listener.sortingChanged();
	}
    }

    /**
       ƥȤ򸽺ߤΥѥ졼ǥȤޤ
    */
    private void sort() {
	Arrays.sort(tests, comparator);
    }

    /**
       ꤵ줿ѥ졼򸽺ߤΥѥ졼ꤷƥȤ򥽡
       Ȥޤ

       @param c ƥȤΥѥ졼
    */
    private void sortBy(Comparator<Test> c) {
	comparator = c;
	sort();
	notifySortKeyChanged();
    }

    /**
       ƥȤξ֤ǥƥȤ򥽡Ȥޤ
    */
    public final void sortByStatus() {
	sortBy(statusComparator);
    }

    /**
       ƥȤΥ᥽å̾ǥƥȤ򥽡Ȥޤ
    */
    public final void sortByName() {
	sortBy(nameComparator);
    }

    /**
       ƥȤΥ饹̾ǥƥȤ򥽡Ȥޤ
    */
    public final void sortByClass() {
	sortBy(classComparator);
    }

    /**
       ʤ߾郎ѹˤʤäȤꥹʤΤޤ
    */
    private void notifyFilterChanged() {
	for (FunnelListener listener : listeners) {
	    listener.filterChanged();
	}
    }

    /**
       ƥоݤꤷޤ

       @param c ƥȤΥ쥯
    */
    private void setTests(Collection<Test> c) {
	tests = c.toArray(new Test[0]);
	sort();

	index.clear();
	for (int k = 0; k < tests.length; ++k) {
	    index.put(tests[k], k);
	}
    }

    /**
       饹̾ǥƥȤʤߤޤ

       @param className 饹̾
    */
    public final void setClassFilter(final String className) {
        SortedMap<String, Test> sm = testTree.subMap(className + "#",
						     className + "$");
	setTests(sm.values());
	notifyFilterChanged();
    }

    /**
       ƥȤιʤ߲ޤ

       եͥ˴ޤޤ뤹٤ƤΥƥȤоݤˤʤޤ
    */
    public final void setDefaultFilter() {
	setTests(testTree.values());
	notifyFilterChanged();
    }

    /**
       ƥȤޤ

       @param className 饹̾
       @return 
    */
    public final String getDescription(final String className) {
	return descriptions.get(className);
    }
}
