package com.maroontress.testfunnel.auditor;

import java.awt.GridLayout;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JProgressBar;

/**
   ƥȤ¹Ԥ륵Хȡ
*/
public class Runner extends Servant {

    /** ƥȥեͥ */
    private Funnel funnel;

    /** åɤȯ㳰Τꥹ */
    private ExceptionListener listener;

    /** ץ饤Υ꡼ */
    private ReplyReader<StatusReply> replyReader;

    /** Funnelؤνϥȥ꡼ */
    private DataOutputStream out;

    /**
       ƥȤ¹Ԥ륵ХȤޤ

       @param parent ƥȼ¹ɽֿĽפοƤȤ
       ե졼
       @param receiver 쥷
       @param out ϥȥ꡼
       @param funnel ƥȥեͥ
       @param listener åɼ¹Իȯ㳰Τ뤿
       ꥹ
    */
    public Runner(final JFrame parent, final Receiver receiver,
		  final DataOutputStream out, final Funnel funnel,
		  final ExceptionListener listener) {
	super(parent, "Stop");
	this.funnel = funnel;
	this.listener = listener;
	this.out = out;
	replyReader = new ReplyReader<StatusReply>(receiver) {
	    protected StatusReply getReply(byte[] data)
	    throws ProtocolException {
		return new StatusReply(data);
	    }
	};
    }

    /**
       ƥȤ¹Ԥƥƥȷ̤򹹿ޤ
    */
    protected final void run() {
	int n = funnel.getTestSize();
	for (int k = 0; k < n; ++k) {
	    Test t = funnel.getTest(k);
	    t.setStatus(Test.UNTESTED);
	}
	setProgress(0);

	for (int k = 0; !isStopped() && k < n; ++k) {
	    setProgress(k * PROGRESS_MAX / n);
	    Test t = funnel.getTest(k);
	    if (!t.getSelected()) {
		continue;
	    }
	    try {
		t.invoke(out);
	    } catch (IOException e) {
		listener.exceptionCaught(e);
		return;
	    }
	    try {
		StatusReply reply = replyReader.getReply();
		t.setStatus(reply.getStatus());
	    } catch (ProtocolException e) {
		listener.exceptionCaught(e);
		return;
	    } catch (InterruptedException e) {
	    }
	}
    }
}
