#ifndef IMPL_STACK_H
#define IMPL_STACK_H

#include <Stack.h>

struct StackNode {
    struct StackNode *next;
    struct StackCell *value;
};

struct Stack {
    int nodes;
    int capacity;
    union {
	struct StackNode *node;
	struct StackCell **cell;
    } top;
    void (*free)(struct Stack *);
    int (*push)(struct Stack *, struct StackCell *);
    struct StackCell *(*pop)(struct Stack *);
    struct StackCell *(*peek)(struct Stack *);
};

#endif /* !IMPL_STACK_H */
