static struct StackCell {
    int value;
} c1, c2, c3;
static struct Stack *s;

static void
initialize(void)
{
    c1.value = 1;
    c2.value = 2;
    c3.value = 3;
}

TF_METHOD(push1)
{
    int e;

    e = Stack_push(s, &c1);
    tf_assert(e == STACK_SUCCESS);
}

TF_METHOD(push2)
{
    int e;

    (void)Stack_push(s, &c1);
    e = Stack_push(s, &c2);
    tf_assert(e == STACK_SUCCESS);
}

TF_METHOD(pop0)
{
    struct StackCell *c;

    c = Stack_pop(s);
    tf_assert(c == NULL);
}

TF_METHOD(pop1)
{
    struct StackCell *c;

    (void)Stack_push(s, &c1);
    c = Stack_pop(s);
    tf_assert(c == &c1 && c->value == 1);
    c = Stack_pop(s);
    tf_assert(c == NULL);
}

TF_METHOD(pop2)
{
    struct StackCell *c;

    (void)Stack_push(s, &c1);
    (void)Stack_push(s, &c2);
    c = Stack_pop(s);
    tf_assert(c == &c2 && c->value == 2);
    c = Stack_pop(s);
    tf_assert(c == &c1 && c->value == 1);
    c = Stack_pop(s);
    tf_assert(c == NULL);
}


TF_METHOD(top0)
{
    struct StackCell *c;

    c = Stack_top(s);
    tf_assert(c == NULL);
}

TF_METHOD(top1)
{
    struct StackCell *c;

    (void)Stack_push(s, &c1);
    c = Stack_top(s);
    tf_assert(c == &c1 && c->value == 1);
    c = Stack_top(s);
    tf_assert(c == &c1 && c->value == 1);
}

TF_METHOD(top2)
{
    struct StackCell *c;

    (void)Stack_push(s, &c1);
    (void)Stack_push(s, &c2);
    c = Stack_top(s);
    tf_assert(c == &c2 && c->value == 2);
    c = Stack_top(s);
    tf_assert(c == &c2 && c->value == 2);
}

TF_METHOD(getSize0)
{
    tf_assert(Stack_getSize(s) == 0);
}

TF_METHOD(getSize1)
{
    (void)Stack_push(s, &c1);
    tf_assert(Stack_getSize(s) == 1);
}

TF_METHOD(getSize2)
{
    (void)Stack_push(s, &c1);
    (void)Stack_push(s, &c2);
    tf_assert(Stack_getSize(s) == 2);
}

TF_METHOD(getSize10)
{
    (void)Stack_push(s, &c1);
    (void)Stack_pop(s);
    tf_assert(Stack_getSize(s) == 0);
}

TF_METHOD(getSize21)
{
    (void)Stack_push(s, &c1);
    (void)Stack_push(s, &c2);
    (void)Stack_pop(s);
    tf_assert(Stack_getSize(s) == 1);
}

TF_METHOD(getSize20)
{
    (void)Stack_push(s, &c1);
    (void)Stack_push(s, &c2);
    (void)Stack_pop(s);
    (void)Stack_pop(s);
    tf_assert(Stack_getSize(s) == 0);
}
