#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <err.h>
#include <tf/TestFunnel.h>

const char tf_description[] = "\
This is the string of <tt>tf_description</tt>. Functions described \
below are examples using <b>Test Funnel API</b>.";

void
tf_initialize(void)
{
    warnx("%s:%s", __FILE__, __FUNCTION__);
}

void
tf_finalize(void)
{
    warnx("%s:%s", __FILE__, __FUNCTION__);
}

TF_METHOD(success_when_returns)
{
    warnx("%s:%s", __FILE__, __FUNCTION__);
}

TF_METHOD(fail_by_assert)
{
    warnx("%s:%s", __FILE__, __FUNCTION__);
    tf_assert(1 < 2);
    tf_assert(1 < 0);
}

TF_METHOD(explicit_fail)
{
    warnx("%s:%s", __FILE__, __FUNCTION__);
    tf_fail("this method always fails.");
}

TF_METHOD(stall_long_time)
{
    warnx("%s:%s", __FILE__, __FUNCTION__);
    sleep(10);
}

TF_METHOD(segmentation_fault)
{
    char *p = NULL;

    warnx("%s:%s", __FILE__, __FUNCTION__);
    *p = 0;
}

extern void foo(void);
extern void bar(void);

void
foo(void)
{
    tf_printStackTrace();
}

void
bar(void)
{
    foo();
}

TF_METHOD(stack_trace)
{
    warnx("%s:%s", __FILE__, __FUNCTION__);
    bar();
}

static void
leak(void)
{
    (void *)strdup("ignored");
}

TF_METHOD(memory_leak)
{
    char *s1, *s2;

    warnx("%s:%s", __FILE__, __FUNCTION__);

    tf_permitMemoryLeak(leak);
    s1 = strdup("hello");
    s2 = strdup("world");
    warnx("%s:%s", s1, s2);
    free(s1);
}
