#define com_maroontress_testfunnel_funnel_StackFrame_IMPORT
#define com_maroontress_testfunnel_funnel_VMATranslator_IMPORT
#define std_lang_String_IMPORT

#include <stdio.h>
#include <stdint.h>
#include <err.h>
#include <com/maroontress/testfunnel/funnel/StackFrame.h>
#include <com/maroontress/testfunnel/funnel/VMATranslator.h>
#include <std/lang/String.h>

typedef intptr_t * StackFrame;

#define FP_NEXT(x) ((StackFrame)((x)[0]))
#define FP_RETURN_IP(x) ((x)[1])
#define FP_IS_ROOT(x) (FP_NEXT(x) == 0 || FP_RETURN_IP(x) == 0)

void
StackFrame_printStackTrace(int maxDepth)
{
    struct VMATranslator *x;
    StackFrame fp;
    int k;

    fp = __builtin_frame_address(1);
    if ((x = VMATranslator_create()) == NULL) {
	warnx("VMATranslator_create() failed.");
	return;
    }
    for (k = 0; !FP_IS_ROOT(fp) && k < maxDepth; ++k, fp = FP_NEXT(fp)) {
	VMATranslator_printReturnAddress(x, FP_RETURN_IP(fp));
    }
    VMATranslator_free(x);
    if (k == maxDepth) {
	fprintf(stderr, "...\n");
    }
    String_staticEconomize();
}
