#define com_maroontress_testfunnel_funnel_Status_IMPORT
#define com_maroontress_testfunnel_funnel_Workaround_IMPORT

#include <err.h>
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <com/maroontress/testfunnel/funnel/Status.h>
#include <com/maroontress/testfunnel/funnel/Workaround.h>

static void
allocateFileMutex(void)
{
    const char *path = "/dev/null";
    FILE *fp[FOPEN_MAX - 3];
    unsigned int k, n;

    n = sizeof(fp)/sizeof(*fp);
    for (k = 0; k < n; ++k) {
	fp[k] = fopen(path, "r");
    }
    for (k = 0; k < n; ++k) {
	if (fp[k] == NULL)
	    continue;
	flockfile(fp[k]);
	funlockfile(fp[k]);
	fclose(fp[k]);
    }
    flockfile(stdin);
    funlockfile(stdin);
    flockfile(stdout);
    funlockfile(stdout);
    flockfile(stderr);
    funlockfile(stderr);
}

void
Workaround_processStarted(void)
{
    allocateFileMutex();
}

static void *
run(void *arg)
{
    return arg;
}

static void
allocateThreadCache(void)
{
    /*
      MAX_CACHED_THREADS is defined in /usr/src/lib/libthr/thread/
      thr_list.c.
    */
#define MAX_CACHED_THREADS 100
    unsigned int k, n;
    pthread_t thread[MAX_CACHED_THREADS];
    pthread_attr_t attr;

    if (pthread_attr_init(&attr) != 0) {
	errx(Status_UNKNOWN, "pthread_attr_init() failed");
    }
    if (pthread_attr_setstacksize(&attr, PTHREAD_STACK_MIN) != 0) {
	errx(Status_UNKNOWN, "pthread_attr_setstacksize() failed");
    }
    n = MAX_CACHED_THREADS;
    for (k = 0; k < n; ++k) {
	if (pthread_create(&thread[k], &attr, run, NULL) != 0) {
	    errx(Status_UNKNOWN, "pthread_create() failed");
	}
    }
    for (k = 0; k < n; ++k) {
	if (pthread_join(thread[k], NULL) != 0) {
	    errx(Status_UNKNOWN, "pthread_join() failed");
	}
    }
    if (pthread_attr_destroy(&attr) != 0) {
	errx(Status_UNKNOWN, "pthread_attr_destroy() failed");
    }
}

void
Workaround_childProcessStarted(void)
{
    allocateThreadCache();

    /*
      before calling arc4random(), the global flag __isthreaded must
      be non-zero.

      see: /usr/src/lib/libc/gen/arc4random.c, /usr/src/lib/libc/
      include/libc_private.h
    */
    (void)arc4random();
}
